package com.taover.bazhuayun.analysis.script.orderdownload;

import java.io.File;
import java.util.List;

import com.taover.bazhuayun.analysis.common.exceldeal.ExcelAnnoParser;
import com.taover.bazhuayun.analysis.common.exceldeal.ExcelParser;
import com.taover.bazhuayun.analysis.util.ExcelUtil;
import com.taover.util.UtilHttpByOkHttp;

import cn.hutool.core.io.FileUtil;

public class Main {
	public static final String ossUrlPreffix = "https://8zyun-oss.oss-cn-beijing.aliyuncs.com";
	
	public static void main(String[] args) throws Exception {
		String dirPath = "C:\\Users\\Administrator\\Desktop\\悟空家数据\\0827-0901-原有仓库";
		String urlFileName = "仓库群文件.xlsx";
		String dataDirName = "订单数据";

		List<List<Object>> fieldData = ExcelUtil.readExcelSheet(new File(dirPath+File.separator+urlFileName), false);
		ExcelParser<GroupInfoExcelDataBean> parser = new ExcelAnnoParser<GroupInfoExcelDataBean>();
		List<GroupInfoExcelDataBean> beanData = parser.parse(fieldData, GroupInfoExcelDataBean.class);
		for(GroupInfoExcelDataBean item: beanData) {
			try {
				downloadDatafile(item, dirPath+File.separator+dataDirName);	
			}catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	private static void downloadDatafile(GroupInfoExcelDataBean item, String dataDir) throws Exception {
		byte[] byteData = UtilHttpByOkHttp.downloadFile(ossUrlPreffix+"/"+item.getOssUrl(), null);
		String fileName = item.getOssUrl().substring(item.getOssUrl().lastIndexOf("/")+1);
		File destFile = new File(dataDir);
		if(!destFile.exists()) {
			destFile.mkdirs();
		}
		FileUtil.writeBytes(byteData, dataDir + File.separator + fileName);
	}
}
