package com.taover.bazhuayun.analysis.web.advice;

import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;

import com.taover.util.UtilLog;
import com.taover.util.bean.ResultInfo;
import com.taover.util.bean.ResultInfoException;
import com.taover.util.bean.UtilResultInfo;

@ControllerAdvice("com.taover.bazhuayun.analysis.web.controller.manage")
public class GlobalExceptionHandler {
	@ExceptionHandler(value = Exception.class)
	@ResponseBody
	public ResultInfo handlerException(Exception e) {
		UtilLog.errorForException(e, this.getClass());
		return UtilResultInfo.getFailure(e.getMessage());
	}
	
	@ExceptionHandler(value = ResultInfoException.class)
	@ResponseBody
	public ResultInfo handlerResultInfoException(ResultInfoException e) {			
		return e.toResultInfo();
	}
}