package com.taover.bazhuayun.analysis.web.controller.manage;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang.StringUtils;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.taover.bazhuayun.analysis.web.constants.GlobalConstants;
import com.taover.bazhuayun.analysis.web.form.HeartbeatInstanceCreateForm;
import com.taover.bazhuayun.analysis.web.form.HeartbeatInstanceUpdateForm;
import com.taover.bazhuayun.analysis.web.module.heartbeat.HeartbeatManager;
import com.taover.bazhuayun.analysis.web.repository.AnalysisHeartbeatInstanceRepository;
import com.taover.bazhuayun.analysis.web.repository.AnalysisHeartbeatLogRepository;
import com.taover.bazhuayun.analysis.web.repository.AnalysisHeartbeatReformRepository;
import com.taover.util.bean.ResultInfo;
import com.taover.util.bean.UtilResultInfo;

@RestController("manage.heartbeat")
@RequestMapping("/manage/heartbeat")
public class HeartbeatController {
	@Resource
	private AnalysisHeartbeatInstanceRepository analysisHeartbeatInstanceRepository;
	@Resource
	private AnalysisHeartbeatLogRepository analysisHeartbeatLogRepository;
	@Resource
	private AnalysisHeartbeatReformRepository analysisHeartbeatReformRepository;
	@Resource
	private HeartbeatManager heartbeatManager;

	@GetMapping
	public ResultInfo get(HttpServletRequest request){
		String pageStr = request.getParameter("page");
		if(StringUtils.isEmpty(pageStr)){
			pageStr = "1";
		}
		String sizeStr = request.getParameter("size");
		if(StringUtils.isEmpty(sizeStr)){
			sizeStr = "10";
		}
		return UtilResultInfo.getSuccess("", this.analysisHeartbeatInstanceRepository.findPageBySql("1=1 order by id desc ", Integer.valueOf(pageStr), Integer.valueOf(sizeStr), null));
	}

	@GetMapping("/{code}")
	public ResultInfo get(@PathVariable String code){
		try {
			return UtilResultInfo.getSuccess("", this.analysisHeartbeatInstanceRepository.findEntityBySql("code='"+code+"'", null));
		} catch (Exception e) {
			return UtilResultInfo.getFailure("not found record");
		}
	}
	
	@GetMapping("/{code}/log")
	public ResultInfo getLog(@PathVariable String code,
			@RequestParam(defaultValue = ""+GlobalConstants.DEFAULT_QUERY_PAGE) Integer page,
			@RequestParam(defaultValue = ""+GlobalConstants.DEFAULT_QUERY_PAGE_SIZE) Integer size){
		try {
			return UtilResultInfo.getSuccess("", this.analysisHeartbeatLogRepository.findPageBySql("instance_code='"+code+"' order by id desc ", page, size, null));
		} catch (Exception e) {
			return UtilResultInfo.getFailure("not found record");
		}
	}
	
	@GetMapping("/{code}/reform")
	public ResultInfo getReform(@PathVariable String code,
			@RequestParam(defaultValue = ""+GlobalConstants.DEFAULT_QUERY_PAGE) Integer page,
			@RequestParam(defaultValue = ""+GlobalConstants.DEFAULT_QUERY_PAGE_SIZE) Integer size){
		try {
			return UtilResultInfo.getSuccess("", this.analysisHeartbeatReformRepository.findPageBySql("instance_code='"+code+"' order by id desc ", page, size, null));
		} catch (Exception e) {
			return UtilResultInfo.getFailure("not found record");
		}
	}
	
	@PostMapping
	public ResultInfo post(@RequestBody HeartbeatInstanceCreateForm form){
		this.heartbeatManager.createInstance(form);
		return UtilResultInfo.getSuccess("创建成功");
	}
	
	@DeleteMapping("/{code}")
	public ResultInfo delete(@PathVariable String code){
		this.heartbeatManager.deleteInstance(code);
		return UtilResultInfo.getSuccess("删除成功");
	}
	
	@PutMapping("/{code}")
	public ResultInfo put(@PathVariable String code, @RequestBody HeartbeatInstanceUpdateForm form){
		this.heartbeatManager.updateInstance(code, form);
		return UtilResultInfo.getSuccess("更新成功");
	}
	
	@PutMapping("/{code}/enable")
	public ResultInfo putEnable(@PathVariable String code){
		this.heartbeatManager.enableInstanceByCode(code);
		return UtilResultInfo.getSuccess("监控启用成功");
	}
	
	@PutMapping("/{code}/disable")
	public ResultInfo putDisable(@PathVariable String code){
		this.heartbeatManager.disableInstanceByCode(code);
		return UtilResultInfo.getSuccess("监控停用成功");
	}
}
