package com.taover.bazhuayun.analysis.web.form;

import java.lang.reflect.Field;
import java.util.HashMap;
import java.util.Map;

import com.taover.util.UtilString;

public abstract class BaseForm {
	private static Map<Class<? extends BaseForm>, Field[]> CACHE_FIELDS_BY_CLASS = new HashMap<Class<? extends BaseForm>, Field[]>();
	
	/**
	 * 通过正则表达式去除所有字符串左右空白字符
	 */
	public void trimByRegexS(){
		Class<? extends BaseForm> thisClass = this.getClass();
		Field[] fieldArr = CACHE_FIELDS_BY_CLASS.get(thisClass);
		if(fieldArr == null) {
			fieldArr = thisClass.getDeclaredFields();
			CACHE_FIELDS_BY_CLASS.put(thisClass, fieldArr);
		}
		for(int i=0; i<fieldArr.length; ++i){
			Field fieldItem = fieldArr[i];
			fieldItem.setAccessible(true);
			if(fieldItem.getType().getSimpleName().equals("String")){
				try {
					fieldItem.set(this, UtilString.trimByRegexS((String)fieldItem.get(this)));
				} catch (IllegalArgumentException e) {
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	@Override
	public String toString() {
		Class<? extends BaseForm> thisClass = this.getClass();		
		Field[] fieldArr = CACHE_FIELDS_BY_CLASS.get(thisClass);
		if(fieldArr == null) {
			fieldArr = thisClass.getDeclaredFields();
			CACHE_FIELDS_BY_CLASS.put(thisClass, fieldArr);
		}				
		StringBuffer result = new StringBuffer();
		for(int i=0; i<fieldArr.length; ++i){
			Field fieldItem = fieldArr[i];
			if(!fieldItem.isAccessible()) {
				fieldItem.setAccessible(true);	
			}
			try {
				Object data = fieldItem.get(this);
				if(data != null) {
					result.append("["+fieldItem.getName()+":"+data.toString()+"]");
				}
			} catch (IllegalArgumentException e) {
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				e.printStackTrace();
			}
		}
		return result.toString();
	}
}
