package com.taover.bazhuayun.analysis.web.form;

import java.util.Date;

import org.apache.commons.lang.StringUtils;

import com.taover.util.UtilString;

import cn.hutool.core.date.DateUtil;

public abstract class BaseSearchForm extends BaseForm{
	public String sortBy;
	public String sortOrder;
	public String originOrderBySql;

	public String getSortBy() {
		return sortBy;
	}

	public void setSortBy(String sortBy) {
		this.sortBy = sortBy;
	}

	public String getSortOrder() {
		return sortOrder;
	}

	public void setSortOrder(String sortOrder) {
		this.sortOrder = sortOrder;
	}

	public String getOriginOrderBySql() {
		return originOrderBySql;
	}

	public void setOriginOrderBySql(String originOrderBySql) {
		this.originOrderBySql = originOrderBySql;
	}

	public String createDateStartSql(Date startDate, String columnSql){
		return " AND " + columnSql + ">='" + DateUtil.formatDateTime(startDate) +"' ";
	}
	
	public String createDateEndSql(Date endDate, String columnSql){
		return " AND " + columnSql + "<='" + DateUtil.formatDateTime(endDate) + "' ";
	}
	
	public String createGreaterEqualSql(Object value, String columnSql){
		if(value == null) {
			return "";
		}
		return " AND " + columnSql + ">=" + value.toString();
	}
	
	public String createLessEqualSql(Object value, String columnSql){
		if(value == null) {
			return "";
		}
		return " AND " + columnSql + "<=" + value.toString();
	}
	
	public String createLikeSql(String likeStr, String columnSql){
		if(likeStr == null) {
			return "";
		}
		return " AND "+columnSql+" like '%"+this.preDealSqlKeyword(likeStr)+"%'";
	}
	
	public String createRightLikeSql(String likeStr, String columnSql){
		if(likeStr == null) {
			return "";
		}
		return " AND "+columnSql+" like '"+this.preDealSqlKeyword(likeStr)+"%'";
	}
	
	public String createEqualsSql(Object value, String columnSql){
		if(value == null) {
			return "";
		}
		return " AND "+columnSql+"='"+this.preDealSqlKeyword(value.toString())+"'";
	}
	
	public String createInSql(String[] inArray, String columnSql){
		return " AND "+columnSql+" IN('"+StringUtils.join(inArray, "','")+"')";
	}
	
	public String createInSql(Integer[] inArray, String columnSql){
		return " AND "+columnSql+" IN("+StringUtils.join(inArray, ",")+")";
	}
	
	public String createInSql(Long[] inArray, String columnSql){
		return " AND "+columnSql+" IN("+StringUtils.join(inArray, ",")+")";
	}
	
	public String getOrderBySql(String defaultOrderBySql) {
		if(StringUtils.isNotBlank(this.getOriginOrderBySql())) {
			return " ORDER BY "+this.getOriginOrderBySql();
		}else if(StringUtils.isNotBlank(this.getSortBy()) && StringUtils.isNotBlank(this.getSortOrder())) {
			return " ORDER BY "+UtilString.underscoreName(this.getSortBy()).toLowerCase()+" "+this.getSortOrder();
		}
		return defaultOrderBySql;
	}
	
	public String preDealSqlKeyword(String value) {
		if(value == null) {
			return "";
		}
		return value.replaceAll("\\\\", "\\\\\\\\\\\\\\\\").replaceAll("'", "\\\\'");
	}
}
