package com.taover.bazhuayun.analysis.web.form;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Id;

public abstract class BaseUpdateForm extends BaseForm{
	
	/**
	 * 转换为数据库字段更新数组
	 * @return
	 */
	public List<Object[]> getSQLUpdateList(){
		List<Object[]> result = new ArrayList<Object[]>();
		Field[] fieldArr = this.getClass().getDeclaredFields();
		for(int i=0; i<fieldArr.length; ++i){
			Field fieldItem = fieldArr[i];
			fieldItem.setAccessible(true);
			Id annoId = fieldItem.getDeclaredAnnotation(Id.class);			
			if(annoId != null){
				continue;
			}
			Column annoColumn = fieldItem.getDeclaredAnnotation(Column.class);
			if(annoColumn == null){
				continue;
			}
			try {
				Object value = fieldItem.get(this);
				if(value == null){
					continue;
				}
				result.add(new Object[]{annoColumn.name(), value});
			} catch (IllegalArgumentException e) {
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				e.printStackTrace();
			}
		}
		return result;
	}
}
