package com.taover.bazhuayun.analysis.web.module.heartbeat;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import com.taover.bazhuayun.analysis.web.form.HeartbeatInstanceCreateForm;
import com.taover.bazhuayun.analysis.web.form.HeartbeatInstanceUpdateForm;
import com.taover.bazhuayun.analysis.web.repository.AnalysisHeartbeatInstanceEntity;
import com.taover.util.bean.ResultInfo;

public interface HeartbeatManager {
	/**
	 * 加载实例
	 * @param servers
	 */
	void loadInstance(List<AnalysisHeartbeatInstanceEntity> servers) throws Exception;
	
	/**
	 * 创建监控实例
	 * @param form
	 */
	void createInstance(HeartbeatInstanceCreateForm form);
	
	/**
	 * 修改监控实例
	 * @param form
	 */
	void updateInstance(String code, HeartbeatInstanceUpdateForm form);
	
	/**
	 * 停用监控实例
	 * @param code
	 */
	void disableInstanceByCode(String code);
	
	/**
	 * 启用监控实例
	 * @param code
	 */
	void enableInstanceByCode(String code);
	
	/**
	 * 处理客户端心跳请求
	 * @param clientRequest
	 * @return
	 */
	ResultInfo dealClientRequest(HttpServletRequest request);
	
	/**
	 * 刷新客户端状态
	 */
	void flushClientStatus();
	
	/**
	 * 向服务器发送心跳
	 */
	void sendServerHeartbeat();

	/**
	 * 删除实例
	 * @param id
	 */
	void deleteInstance(String code);
}
