package com.taover.bazhuayun.analysis.web.module.heartbeat.bean;

import javax.servlet.http.HttpServletRequest;

public class ClientRequest {
	private String code = "";
	private String ip = "";
	private long unixtime;
	private String seckey = "";
	
	public String getCode() {
		return code;
	}
	public void setCode(String code) {
		this.code = code;
	}
	public String getIp() {
		return ip;
	}
	public void setIp(String ip) {
		this.ip = ip;
	}
	public long getUnixtime() {
		return unixtime;
	}
	public void setUnixtime(long unixtime) {
		this.unixtime = unixtime;
	}
	public String getSeckey() {
		return seckey;
	}
	public void setSeckey(String seckey) {
		this.seckey = seckey;
	}
	
	public ClientRequest(String code, String ip, long unixtime, String seckey) {
		this.code = code;
		this.ip = ip;
		this.unixtime = unixtime;
		this.seckey = seckey;
	}
	
	public ClientRequest(ClientRequest clientRequest) {
		this.code = clientRequest.getCode();
		this.ip = clientRequest.getIp();
		this.unixtime = clientRequest.getUnixtime();
		this.seckey = clientRequest.getSeckey();
	}
	
	public static ClientRequest createClientRequest(HttpServletRequest request) {
		String code = request.getParameter("code");
		String unixtime = request.getParameter("unixtime");
		String seckey = request.getParameter("seckey");
		String ip = request.getRemoteHost();
		return new ClientRequest(code, ip,
				unixtime==null?0L:Long.valueOf(unixtime),
				seckey);
	}
	
	public String getIdentity() {
		return this.code;
	}
	
	@Override
	public String toString() {
		return "ClientRequest [code=" + code + ", ip=" + ip + ", unixtime=" + unixtime + ", seckey=" + seckey + "]";
	}
}
