package com.taover.bazhuayun.analysis.web.module.heartbeat.holder;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import com.taover.bazhuayun.analysis.web.module.heartbeat.bean.ServerInstance;
import com.taover.bazhuayun.analysis.web.repository.AnalysisHeartbeatInstanceEntity;

public class ServerHolderImpl implements ServerHolder {
	Map<String, ServerInstance> serverMap = new ConcurrentHashMap<String, ServerInstance>();

	@Override
	public List<ServerInstance> getServerInstanceList() {
		return new ArrayList<ServerInstance>(serverMap.values());
	}

	@Override
	public void registryServer(AnalysisHeartbeatInstanceEntity instance) throws Exception {
		ServerInstance server = new ServerInstance(instance);
		serverMap.put(server.getIdentity(), server);
	}

	@Override
	public void flushServerStatus(ServerInstance serverInstance) {
		serverInstance.flush();
	}

	@Override
	public void unregistryServer(String code) {
		serverMap.remove(code);
	}
}
