package com.taover.bazhuayun.analysis.web.module.heartbeat.service;

import javax.annotation.Resource;

import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import com.taover.bazhuayun.analysis.web.module.heartbeat.bean.Instance;
import com.taover.bazhuayun.analysis.web.repository.AnalysisHeartbeatReformEntity;
import com.taover.bazhuayun.analysis.web.repository.AnalysisHeartbeatReformRepository;
import com.taover.util.UtilHttpByOkHttp;
import com.taover.util.UtilLog;

@Service
public class HeartbeatDeployServiceImpl implements HeartbeatDeployService {
	@Resource
	private AnalysisHeartbeatReformRepository analysisHeartbeatReformRepository;
	@Resource
	private HeartbeatReformService heartbeatReformService;

	private void createDeployLog(Instance instance, String response) {
		AnalysisHeartbeatReformEntity reform = new AnalysisHeartbeatReformEntity();
		reform.setInstanceCode(instance.getIdentity());
		reform.setReformContent(response);
		reform.setReformInfo("调用发布URL");
		reform.setReformType(AnalysisHeartbeatReformRepository.REFORM_TYPE_WEIXIN);
		this.analysisHeartbeatReformRepository.addEntity(reform, null);
	}

	@Override
	public void sendDeploy(Instance item) {
		if(item.getInstance() == null || StringUtils.isBlank(item.getInstance().getDeployUrl())) {
			return;
		}
		String deployUrl = item.getInstance().getDeployUrl();
		String[] deployUrlArray = deployUrl.split(";");
		for (int i = 0; i < deployUrlArray.length; i++) {
			String response = null;
			String realDeployUrl = deployUrlArray[i];
			try {
				response = UtilHttpByOkHttp.sendGet(realDeployUrl, null);
				this.heartbeatReformService.sendReformDeploy(item);
			} catch (Exception e) {
				UtilLog.error("调用自动发布URL发生异常，发布URL["+realDeployUrl+"]", e, HeartbeatDeployServiceImpl.class);
				response = e.getMessage();
				this.heartbeatReformService.sendErrorMsg(item, response);
			}
			this.createDeployLog(item, response);
		}
	}
}
