package com.taover.bazhuayun.analysis.web.permission;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.taover.util.UtilLog;

public class HttpHeaderFilter implements Filter{	
	@Override
	public void init(FilterConfig filterConfig) throws ServletException {
		UtilLog.infoForMessage("HttpHeaderFilter:init", this.getClass());
	}

	@Override
	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain)
			throws IOException, ServletException {
		HttpServletResponse httpResponse = (HttpServletResponse) response;
		HttpServletRequest httpRequest = (HttpServletRequest) request;
		
		httpResponse.setHeader("Access-Control-Allow-Origin", httpRequest.getHeader("Origin"));
		httpResponse.setHeader("Access-Control-Allow-Credentials", "true");
		httpResponse.setHeader("Access-Control-Allow-Methods", "POST, GET, OPTIONS, DELETE, PUT, HEAD");
		httpResponse.setHeader("Access-Control-Allow-Headers", "Authorization,content-type");
		httpResponse.setHeader("Access-Control-Expose-Headers", "");
		httpResponse.setHeader("Access-Control-Max-Age", "1728000");
		httpResponse.setHeader("Vary", "Origin");
		httpResponse.setHeader("Access-Control-Expose-Headers", "Content-Disposition");
				
		//跨域prelight options请求直接返回
		if("options".equals(httpRequest.getMethod().toLowerCase())){
			return;
		}
		chain.doFilter(httpRequest, httpResponse);
	}
	
	@Override
	public void destroy() {
		UtilLog.infoForMessage("HttpHeaderFilter:destory", this.getClass());
	}
}
