package com.taover.bazhuayun.analysis.web.permission;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.web.servlet.FilterRegistrationBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class JwtFilterConfig {
	@Value("${db.user.userid.admin}")
	private int adminUserId;
	
	public static final int ORDER_JWT_FILTER = 1;
	
	@Bean
    public FilterRegistrationBean<JwtFilter> jwtFilter() {
        FilterRegistrationBean<JwtFilter> registrationBean = new FilterRegistrationBean<JwtFilter>();
        registrationBean.setFilter(new JwtFilter(adminUserId));
        registrationBean.addUrlPatterns("/manage/*");
        registrationBean.setOrder(ORDER_JWT_FILTER);
        return registrationBean;
    }
}
